# Uses of Interface
org.apache.qpid.proton.codec.ReadableBuffer

Packages that use ReadableBuffer
Package
Description
org.apache.qpid.proton.amqp
org.apache.qpid.proton.codec
org.apache.qpid.proton.engine
org.apache.qpid.proton.engine.impl
org.apache.qpid.proton.message
org.apache.qpid.proton.message.impl

## Uses of ReadableBuffer in org.apache.qpid.proton.amqp

Methods in org.apache.qpid.proton.amqp with parameters of type ReadableBuffer
Modifier and Type
Method
Description
`static Binary`
Binary.`create(ReadableBuffer buffer)`

## Uses of ReadableBuffer in org.apache.qpid.proton.codec

Classes in org.apache.qpid.proton.codec that implement ReadableBuffer
Modifier and Type
Class
Description
`class`
`CompositeReadableBuffer`
ReadableBuffer implementation whose content is made up of one or more byte arrays.
`static final class`
`ReadableBuffer.ByteBufferReader`
Methods in org.apache.qpid.proton.codec that return ReadableBuffer
Modifier and Type
Method
Description
`ReadableBuffer`
ReadableBuffer.ByteBufferReader.`clear()`
`ReadableBuffer`
ReadableBuffer.`clear()`
Resets the buffer position to zero and sets the limit to the buffer capacity, the mark value is discarded if set.
`ReadableBuffer`
ReadableBuffer.ByteBufferReader.`duplicate()`
`ReadableBuffer`
ReadableBuffer.`duplicate()`
Creates a duplicate `ReadableBuffer` to this instance.
`ReadableBuffer`
ReadableBuffer.ByteBufferReader.`flip()`
`ReadableBuffer`
ReadableBuffer.`flip()`
Sets the buffer limit to the current position and the position is set to zero, the mark value reset to undefined.
`ReadableBuffer`
ReadableBuffer.ByteBufferReader.`get(byte[] data)`
`ReadableBuffer`
ReadableBuffer.ByteBufferReader.`get(byte[] data, int offset, int length)`
`ReadableBuffer`
ReadableBuffer.ByteBufferReader.`get(WritableBuffer target)`
`ReadableBuffer`
ReadableBuffer.`get(byte[] target)`
A bulk read method that copies bytes from this buffer into the target byte array.
`ReadableBuffer`
ReadableBuffer.`get(byte[] target, int offset, int length)`
A bulk read method that copies bytes from this buffer into the target byte array.
`ReadableBuffer`
ReadableBuffer.`get(WritableBuffer target)`
Copy data from this buffer to the target buffer starting from the current position and continuing until either this buffer's remaining bytes are consumed or the target is full.
`ReadableBuffer`
DecoderImpl.`getBuffer()`
`ReadableBuffer`
ReadableBuffer.ByteBufferReader.`limit(int limit)`
`ReadableBuffer`
ReadableBuffer.`limit(int limit)`
Sets the current read limit of this buffer to the given value.
`ReadableBuffer`
ReadableBuffer.ByteBufferReader.`mark()`
`ReadableBuffer`
ReadableBuffer.`mark()`
Mark the current position of this buffer which can be returned to after a read operation by calling `reset()`.
`ReadableBuffer`
ReadableBuffer.ByteBufferReader.`position(int position)`
`ReadableBuffer`
ReadableBuffer.`position(int position)`
Sets the current position of this buffer to the given value.
`ReadableBuffer`
ReadableBuffer.ByteBufferReader.`reclaimRead()`
`ReadableBuffer`
ReadableBuffer.`reclaimRead()`
Compact the backing storage of this ReadableBuffer, possibly freeing previously-read portions of pooled data or reducing the number of backing arrays if present.
`ReadableBuffer`
ReadableBuffer.ByteBufferReader.`reset()`
`ReadableBuffer`
ReadableBuffer.`reset()`
Reset the buffer's position to a previously marked value, the mark should remain set after calling this method.
`ReadableBuffer`
ReadableBuffer.ByteBufferReader.`rewind()`
`ReadableBuffer`
ReadableBuffer.`rewind()`
Resets the buffer position to zero and clears and previously set mark.
`ReadableBuffer`
ReadableBuffer.ByteBufferReader.`slice()`
`ReadableBuffer`
ReadableBuffer.`slice()`
Creates a new ReadableBuffer instance that is a view of the readable portion of this buffer.
`ReadableBuffer`
WritableBuffer.ByteBufferWrapper.`toReadableBuffer()`
Methods in org.apache.qpid.proton.codec with parameters of type ReadableBuffer
Modifier and Type
Method
Description
`CompositeReadableBuffer`
CompositeReadableBuffer.`append(ReadableBuffer buffer)`
Adds the given readable buffer contents (from current position, up to the limit) into this composite buffer at the end.
`void`
CompositeWritableBuffer.`put(ReadableBuffer payload)`
`void`
DroppingWritableBuffer.`put(ReadableBuffer payload)`
`void`
WritableBuffer.ByteBufferWrapper.`put(ReadableBuffer src)`
`void`
WritableBuffer.`put(ReadableBuffer payload)`
`void`
DecoderImpl.`setBuffer(ReadableBuffer buffer)`

## Uses of ReadableBuffer in org.apache.qpid.proton.engine

Methods in org.apache.qpid.proton.engine that return ReadableBuffer
Modifier and Type
Method
Description
`ReadableBuffer`
Receiver.`recv()`
Receive message data for the current delivery returning the data in a Readable buffer.
Methods in org.apache.qpid.proton.engine with parameters of type ReadableBuffer
Modifier and Type
Method
Description
`int`
Sender.`send(ReadableBuffer buffer)`
Sends some data for the current delivery.
`int`
Sender.`sendNoCopy(ReadableBuffer buffer)`
Sends data to the current delivery attempting not to copy the data unless a previous send has already added data to the Delivery in which case a copy may occur depending on the implementation.

## Uses of ReadableBuffer in org.apache.qpid.proton.engine.impl

Methods in org.apache.qpid.proton.engine.impl that return ReadableBuffer
Modifier and Type
Method
Description
`ReadableBuffer`
ReceiverImpl.`recv()`
Methods in org.apache.qpid.proton.engine.impl with parameters of type ReadableBuffer
Modifier and Type
Method
Description
`void`
FrameWriterBuffer.`put(ReadableBuffer payload)`
`int`
SenderImpl.`send(ReadableBuffer buffer)`
`int`
SenderImpl.`sendNoCopy(ReadableBuffer buffer)`
`protected void`
TransportImpl.`writeFrame(int channel, FrameBody frameBody, ReadableBuffer payload, Runnable onPayloadTooLarge)`

## Uses of ReadableBuffer in org.apache.qpid.proton.message

Methods in org.apache.qpid.proton.message with parameters of type ReadableBuffer
Modifier and Type
Method
Description
`void`
Message.`decode(ReadableBuffer buffer)`
Decodes the Message from the given `ReadableBuffer`.

## Uses of ReadableBuffer in org.apache.qpid.proton.message.impl

Methods in org.apache.qpid.proton.message.impl with parameters of type ReadableBuffer
Modifier and Type
Method
Description
`void`
MessageImpl.`decode(ReadableBuffer buffer)`